// PanFileSelector.h: interface for the CPanFileSelector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PANFILESELECTOR_H__2DDEFFF3_DC30_43ED_941E_B41E2994CDF8__INCLUDED_)
#define AFX_PANFILESELECTOR_H__2DDEFFF3_DC30_43ED_941E_B41E2994CDF8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FileSelector.h"
#import "PanObj.tlb" raw_interfaces_only no_namespace
#include "UISpec.h"
#include "PanDisp.h"
#include "Invalidator.h"
#include "StringProp.h"

class CPanImportImage : public CFileSelector, public CStringProp
{
public:
    virtual ~CPanImportImage();
    CPanImportImage( HWND           hWndParent,
                     LPCTSTR        label,
                     LPCTSTR        defVal,
                     int            nWidth,
                     int            nHeight,
                     IntUpdater*    pUpd,
                     void*          pParamBits,
                     void*          pParamWidth,
                     void*          pParamHeight,
                     CInvalidator*  pInvalid,
                     CComBSTR       docURL);

    BEGIN_MSG_MAP(CPanImportImage)
        COMMAND_CODE_HANDLER(FS_CHANGED, OnChange)
        CHAIN_MSG_MAP(CFileSelector)
    END_MSG_MAP()

    LRESULT OnChange(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

    LPCTSTR GetString();
    void    SetString(LPCTSTR str);

private:

    void LoadImage(char* fileName);

    int                 m_pBits;
    IntUpdater*         m_updateValue;
    void*               m_pParamBits;
    void*               m_pParamWidth;
    void*               m_pParamHeight;
    CInvalidator*       m_iProc;
    LPTSTR              m_fileName;
    CComBSTR            m_docURL;
};

#endif // !defined(AFX_PANFILESELECTOR_H__2DDEFFF3_DC30_43ED_941E_B41E2994CDF8__INCLUDED_)
