// PanTextBox.h: interface for the CPanTextBox class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PANTEXTBOX_H__5C06B87D_B5C5_489A_A86F_D98994919817__INCLUDED_)
#define AFX_PANTEXTBOX_H__5C06B87D_B5C5_489A_A86F_D98994919817__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Box.h"
#include "Button.h"
#include "EditBox.h"

#import "PanObj.tlb" raw_interfaces_only no_namespace
#include "UISpec.h"
#include "PanDisp.h"
#include "StringProp.h"
#include "FontInfo.h"
#include "Invalidator.h"

class CPanTextBox : public CBox, public CStringProp, public CFontProp
{
public:
	CPanTextBox
	    ( HWND              hWndParent
	    , LPCTSTR           label
	    , LPCTSTR           defValue
	    , int               nWidth
	    , int               nHeight
        , IntUpdater*       pUpd
        , void*             pParamBits
        , void*             pParamWidth
        , void*             pParamHeight
        , CInvalidator* iProc
	    );
	virtual ~CPanTextBox();

    BEGIN_MSG_MAP(CPanTextBox)
        COMMAND_CODE_HANDLER(BN_CLICKED, OnClick)
        COMMAND_CODE_HANDLER(EN_CHANGE, OnChange)
        CHAIN_MSG_MAP(CBox)
    END_MSG_MAP()

    LRESULT OnClick(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
    LRESULT OnChange(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

    HWND Create
		( HWND     hWndParent
		, LPCTSTR  label
		, int nWidth
        , int nHeight
		, int selectorID
		);

    LPCTSTR GetString();
    void    SetString(LPCTSTR str);


    void  GetFontInfo(FontInfo* pFontInfo);
    void  SetFontInfo(FontInfo  fontInfo);

private:
    void RenderText(LPCTSTR text, HFONT hFont);

    CEditBox* m_edit;
    CBtn*     m_btn;

    IntUpdater*         m_updateValue;
    void*               m_pParamBits;
    void*               m_pParamWidth;
    void*               m_pParamHeight;
    CInvalidator*   m_iProc;

    LOGFONT             m_lf;
    HFONT               m_hFont;
    HBITMAP             m_hBitmap;
    int                 m_nWidth;
    int                 m_nHeight;
    RGBQUAD*            m_pData;
    COLORREF            m_cRef;

    LPTSTR              m_text;

};

#endif // !defined(AFX_PANTEXTBOX_H__5C06B87D_B5C5_489A_A86F_D98994919817__INCLUDED_)
